/**
 * @license
 * Copyright 2016 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
"use strict";
exports.rules = {
    "adjacent-overload-signatures": true,
    "cyclomatic-complexity": false,
    "no-unsafe-finally": true,
    "object-literal-key-quotes": [true, "as-needed"],
    "object-literal-shorthand": true,
    "only-arrow-functions": [true, "allow-declarations"],
    "ordered-imports": [true, {
            "import-sources-order": "case-insensitive",
            "named-imports-order": "lowercase-last",
        }],
};
// work around "extends" being a keyword
var xtends = "tslint:recommended";
exports.extends = xtends;
