"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var abstractFormatter_1 = require("../language/formatter/abstractFormatter");
var rule_1 = require("../language/rule/rule");
var Utils = require("../utils");
var fs = require("fs");
var Formatter = (function (_super) {
    __extends(Formatter, _super);
    function Formatter() {
        _super.apply(this, arguments);
    }
    /* tslint:enable:object-literal-sort-keys */
    Formatter.prototype.format = function (failures) {
        var files = {};
        failures.map(function (f) { return files[f.getFileName()] = true; });
        var log = [];
        var _loop_1 = function(file) {
            log.push("Applying fixes to " + file);
            var content = fs.readFileSync(file, { encoding: "utf-8" });
            var fixes = failures.filter(function (f) { return f.getFileName() === file; }).map(function (f) { return f.getFix(); }).filter(function (f) { return !!f; });
            content = rule_1.Fix.applyAll(content, fixes);
            fs.writeFileSync(file, content, { encoding: "utf-8" });
        };
        for (var _i = 0, _a = Object.keys(files); _i < _a.length; _i++) {
            var file = _a[_i];
            _loop_1(file);
        }
        log.push("All done. Remember to test the changes, as not all fixes preserve semantics.");
        return log.join("\n") + "\n";
    };
    /* tslint:disable:object-literal-sort-keys */
    Formatter.metadata = {
        formatterName: "applyFixes",
        description: "Automatically fixes lint failures.",
        descriptionDetails: (_a = ["\n            Modifies source files and applies fixes for lint failures where possible. Changes\n            should be tested as not all fixes preserve semantics."], _a.raw = ["\n            Modifies source files and applies fixes for lint failures where possible. Changes\n            should be tested as not all fixes preserve semantics."], Utils.dedent(_a)),
        sample: (_b = ["\n            All done. Remember to test the changes, as not all fixes preserve semantics."], _b.raw = ["\n            All done. Remember to test the changes, as not all fixes preserve semantics."], Utils.dedent(_b)),
        consumer: "machine",
    };
    return Formatter;
    var _a, _b;
}(abstractFormatter_1.AbstractFormatter));
exports.Formatter = Formatter;
