/**
 * @license
 * Copyright 2013 Palantir Technologies, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import * as configuration from "./configuration";
import * as formatters from "./formatters";
import { RuleFailure } from "./language/rule/rule";
import * as rules from "./rules";
import * as test from "./test";
import * as linter from "./tslint";
import * as utils from "./utils";
export * from "./language/rule/rule";
export * from "./enableDisableRules";
export * from "./formatterLoader";
export * from "./ruleLoader";
export * from "./language/utils";
export * from "./language/languageServiceHost";
export * from "./language/walker";
export * from "./language/formatter/formatter";
export declare var Configuration: typeof configuration;
export declare var Formatters: typeof formatters;
export declare var Linter: typeof linter;
export declare var Rules: typeof rules;
export declare var Test: typeof test;
export declare var Utils: typeof utils;
export interface LintResult {
    failureCount: number;
    failures: RuleFailure[];
    format: string | Function;
    output: string;
}
export interface ILinterOptionsRaw {
    configuration?: any;
    formatter?: string | Function;
    formattersDirectory?: string;
    rulesDirectory?: string | string[];
}
export interface ILinterOptions extends ILinterOptionsRaw {
    configuration: any;
    formatter: string | Function;
    rulesDirectory: string | string[];
}
export interface IMultiLinterOptions {
    formatter?: string | Function;
    formattersDirectory?: string;
    rulesDirectory?: string | string[];
}
